<?php

namespace FiloBlu\CustomerBlocker\Observer\Sales;

class PaypalOrderPlaceBefore extends OrderPlaceBeforeAbstract {

    /**
     * Execute observer
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     */
    public function execute(
        \Magento\Framework\Event\Observer $observer
    ) {
        if($this->helper->isModuleEnable())
        {
            $order_email = $observer->getEvent()->getQuote()->getBillingAddress()->getEmail();

            $emailToBlock = $this->helper->isEmailToBeBlocked($order_email);
            $custormerAddressToBlock = $this->checkCustomerAddress($observer, true);

            if($custormerAddressToBlock || $emailToBlock) {
                throw new \Magento\Framework\Exception\LocalizedException(__("Sorry, your order cannot be processed."));
            }
        }

        if($this->helper->isCheckOrderAddressEnable())
        {
            $quote = $observer->getEvent()->getQuote();
            $msgDataIncomlete = "";

            $billignDataComplete = $this->helper->checkBillingAndShippingData($quote->getBillingAddress()->getData());

            if(!$quote->isVirtual()){
                $shippingDataComplete = $this->helper->checkBillingAndShippingData($quote->getShippingAddress()->getData());

                if(!$shippingDataComplete || !$billignDataComplete)
                {
                    $msgDataIncomlete = "Incomplete shipping or billing address data. Enter the missing data to place the order.";
                }
            }
            else{
                if(!$billignDataComplete)
                {
                    $msgDataIncomlete = "Incomplete billing address data. Enter the missing data to place the order.";
                }
            }

            if($msgDataIncomlete != "")
            {
                throw new \Magento\Framework\Exception\LocalizedException(__($msgDataIncomlete));
            }
        }
    }
}